Index: inc/dbschema/db-schema.php
===================================================================
--- inc/dbschema/db-schema.php	(revision 2566)
+++ inc/dbschema/db-schema.php	(revision 3231)
@@ -19,12 +19,12 @@
 -------------------------------------------------------- */
 $_s->blog
-	->blog_id		('varchar',	32,	false)
-	->blog_uid	('varchar',	32,	false)
-	->blog_creadt	('timestamp',	0,	false,	'now()')
-	->blog_upddt	('timestamp',	0,	false,	'now()')
-	->blog_url	('varchar',	255,	false)
-	->blog_name	('varchar',	255,	false)
-	->blog_desc	('text',		0,	true)
-	->blog_status	('smallint',	0,	false,	1)
+	->blog_id				('varchar',		32,		false)
+	->blog_uid				('varchar',		32,		false)
+	->blog_creadt			('timestamp',	0,		false,	'now()')
+	->blog_upddt			('timestamp',	0,		false,	'now()')
+	->blog_url				('varchar',		255,	false)
+	->blog_name				('varchar',		255,	false)
+	->blog_desc				('text',		0,		true)
+	->blog_status			('smallint',	0,		false,	1)
 
 	->primary('pk_blog','blog_id')
@@ -32,12 +32,12 @@
 
 $_s->category
-	->cat_id		('bigint',	0,	false)
-	->blog_id		('varchar',	32,	false)
-	->cat_title	('varchar',	255,	false)
-	->cat_url		('varchar',	255,	false)
-	->cat_desc	('text',		0,	true)
-	->cat_position	('integer',	0,	true,	0)
-	->cat_lft		('integer',	0,	true)
-	->cat_rgt		('integer',	0,	true)
+	->cat_id				('bigint',		0,		false)
+	->blog_id				('varchar',		32,		false)
+	->cat_title				('varchar',		255,	false)
+	->cat_url				('varchar',		255,	false)
+	->cat_desc				('text',		0,		true)
+	->cat_position			('integer',		0,		true,	0)
+	->cat_lft				('integer',		0,		true)
+	->cat_rgt				('integer',		0,		true)
 
 	->primary('pk_category','cat_id')
@@ -47,8 +47,8 @@
 
 $_s->session
-	->ses_id		('varchar',	40,	false)
-	->ses_time	('integer',	0,	false,	0)
-	->ses_start	('integer',	0,	false,	0)
-	->ses_value	('text',		0,	false)
+	->ses_id				('varchar',		40,		false)
+	->ses_time				('integer',		0,		false,	0)
+	->ses_start				('integer',		0,		false,	0)
+	->ses_value				('text',		0,		false)
 
 	->primary('pk_session','ses_id')
@@ -56,10 +56,10 @@
 
 $_s->setting
-	->setting_id		('varchar',	255,	false)
-	->blog_id			('varchar',	32,	true)
-	->setting_ns		('varchar',	32,	false,	"'system'")
-	->setting_value	('text',		0,	true,	null)
-	->setting_type		('varchar',	8,	false,	"'string'")
-	->setting_label	('text',		0,	true)
+	->setting_id			('varchar',		255,	false)
+	->blog_id				('varchar',		32,		true)
+	->setting_ns			('varchar',		32,		false,	"'system'")
+	->setting_value			('text',		0,		true,	null)
+	->setting_type			('varchar',		8,		false,	"'string'")
+	->setting_label			('text',		0,		true)
 
 	->unique('uk_setting','setting_ns','setting_id','blog_id')
@@ -67,23 +67,23 @@
 
 $_s->user
-	->user_id			('varchar',	32,	false)
-	->user_super		('smallint',	0,	true)
-	->user_status		('smallint',	0,	false,	1)
-	->user_pwd		('varchar',	40,	false)
-	->user_change_pwd	('smallint',	0,	false,	0)
-	->user_recover_key	('varchar',	32,	true,	null)
-	->user_name		('varchar',	255,	true,	null)
-	->user_firstname	('varchar',	255,	true,	null)
-	->user_displayname	('varchar',	255,	true,	null)
-	->user_email		('varchar',	255,	true,	null)
-	->user_url		('varchar',	255,	true,	null)
-	->user_desc		('text',		0,	true)
-	->user_default_blog	('varchar',	32,	true,	null)
-	->user_options		('text',		0,	true)
-	->user_lang		('varchar',	5,	true,	null)
-	->user_tz			('varchar',	128,	false,	"'UTC'")
-	->user_post_status	('smallint',	0,	false,	-2)
-	->user_creadt		('timestamp',	0,	false,	'now()')
-	->user_upddt		('timestamp',	0,	false,	'now()')
+	->user_id				('varchar',		32,		false)
+	->user_super			('smallint',	0,		true)
+	->user_status			('smallint',	0,		false,	1)
+	->user_pwd				('varchar',		255,	false)
+	->user_change_pwd		('smallint',	0,		false,	0)
+	->user_recover_key		('varchar',		32,		true,	null)
+	->user_name				('varchar',		255,	true,	null)
+	->user_firstname		('varchar',		255,	true,	null)
+	->user_displayname		('varchar',		255,	true,	null)
+	->user_email			('varchar',		255,	true,	null)
+	->user_url				('varchar',		255,	true,	null)
+	->user_desc				('text',		0,		true)
+	->user_default_blog		('varchar',		32,		true,	null)
+	->user_options			('text',		0,		true)
+	->user_lang				('varchar',		5,		true,	null)
+	->user_tz				('varchar',		128,	false,	"'UTC'")
+	->user_post_status		('smallint',	0,		false,	-2)
+	->user_creadt			('timestamp',	0,		false,	'now()')
+	->user_upddt			('timestamp',	0,		false,	'now()')
 
 	->primary('pk_user','user_id')
@@ -91,7 +91,7 @@
 
 $_s->permissions
-	->user_id		('varchar',	32,	false)
-	->blog_id		('varchar',	32,	false)
-	->permissions	('text',		0,	true)
+	->user_id				('varchar',		32,		false)
+	->blog_id				('varchar',		32,		false)
+	->permissions			('text',		0,		true)
 
 	->primary('pk_permissions','user_id','blog_id')
@@ -99,32 +99,32 @@
 
 $_s->post
-	->post_id				('bigint',	0,	false)
-	->blog_id				('varchar',	32,	false)
-	->user_id				('varchar',	32,	false)
-	->cat_id				('bigint',	0,	true)
-	->post_dt				('timestamp',	0,	false,	'now()')
-	->post_tz				('varchar',	128,	false,	"'UTC'")
-	->post_creadt			('timestamp',	0,	false,	'now()')
-	->post_upddt			('timestamp',	0,	false,	'now()')
-	->post_password		('varchar',	32,	true,	null)
-	->post_type			('varchar',	32,	false,	"'post'")
-	->post_format			('varchar',	32,	false,	"'xhtml'")
-	->post_url			('varchar',	255,	false)
-	->post_lang			('varchar',	5,	true,	null)
-	->post_title			('varchar',	255,	true,	null)
-	->post_excerpt			('text',		0,	true,	null)
-	->post_excerpt_xhtml	('text',		0,	true,	null)
-	->post_content			('text',		0,	true,	null)
-	->post_content_xhtml	('text',		0,	false)
-	->post_notes			('text',		0,	true,	null)
-	->post_meta			('text',		0,	true,	null)
-	->post_words			('text',		0,	true,	null)
-	->post_status			('smallint',	0,	false,	0)
-	->post_selected		('smallint',	0,	false,	0)
-	->post_position		('integer',	0,	false,	0)
-	->post_open_comment		('smallint',	0,	false,	0)
-	->post_open_tb			('smallint',	0,	false,	0)
-	->nb_comment			('integer',	0,	false,	0)
-	->nb_trackback			('integer',	0,	false,	0)
+	->post_id				('bigint',		0,		false)
+	->blog_id				('varchar',		32,		false)
+	->user_id				('varchar',		32,		false)
+	->cat_id				('bigint',		0,		true)
+	->post_dt				('timestamp',	0,		false,	'now()')
+	->post_tz				('varchar',		128,	false,	"'UTC'")
+	->post_creadt			('timestamp',	0,		false,	'now()')
+	->post_upddt			('timestamp',	0,		false,	'now()')
+	->post_password			('varchar',		32,		true,	null)
+	->post_type				('varchar',		32,		false,	"'post'")
+	->post_format			('varchar',		32,		false,	"'xhtml'")
+	->post_url				('varchar',		255,	false)
+	->post_lang				('varchar',		5,		true,	null)
+	->post_title			('varchar',		255,	true,	null)
+	->post_excerpt			('text',		0,		true,	null)
+	->post_excerpt_xhtml	('text',		0,		true,	null)
+	->post_content			('text',		0,		true,	null)
+	->post_content_xhtml	('text',		0,		false)
+	->post_notes			('text',		0,		true,	null)
+	->post_meta				('text',		0,		true,	null)
+	->post_words			('text',		0,		true,	null)
+	->post_status			('smallint',	0,		false,	0)
+	->post_selected			('smallint',	0,		false,	0)
+	->post_position			('integer',		0,		false,	0)
+	->post_open_comment		('smallint',	0,		false,	0)
+	->post_open_tb			('smallint',	0,		false,	0)
+	->nb_comment			('integer',		0,		false,	0)
+	->nb_trackback			('integer',		0,		false,	0)
 
 	->primary('pk_post','post_id')
@@ -134,15 +134,15 @@
 
 $_s->media
-	->media_id		('bigint',	0,	false)
-	->user_id			('varchar',	32,	false)
-	->media_path		('varchar',	255,	false)
-	->media_title		('varchar',	255,	false)
-	->media_file		('varchar',	255,	false)
-	->media_dir		('varchar',	255,	false,	"'.'")
-	->media_meta		('text',		0,	true,	null)
-	->media_dt		('timestamp',	0,	false,	'now()')
-	->media_creadt		('timestamp',	0,	false,	'now()')
-	->media_upddt		('timestamp',	0,	false,	'now()')
-	->media_private	('smallint',	0,	false,	0)
+	->media_id				('bigint',		0,		false)
+	->user_id				('varchar',		32,		false)
+	->media_path			('varchar',		255,	false)
+	->media_title			('varchar',		255,	false)
+	->media_file			('varchar',		255,	false)
+	->media_dir				('varchar',		255,	false,	"'.'")
+	->media_meta			('text',		0,		true,	null)
+	->media_dt				('timestamp',	0,		false,	'now()')
+	->media_creadt			('timestamp',	0,		false,	'now()')
+	->media_upddt			('timestamp',	0,		false,	'now()')
+	->media_private			('smallint',	0,		false,	0)
 
 	->primary('pk_media','media_id')
@@ -150,7 +150,7 @@
 
 $_s->post_media
-	->media_id	('bigint',	0,	false)
-	->post_id		('bigint',	0,	false)
-	->link_type		('varchar',	32,	false,	"'attachment'")
+	->media_id				('bigint',		0,		false)
+	->post_id				('bigint',		0,		false)
+	->link_type				('varchar',		32,		false,	"'attachment'")
 
 	->primary('pk_post_media','media_id','post_id','link_type')
@@ -158,11 +158,11 @@
 
 $_s->log
-	->log_id		('bigint',	0,	false)
-	->user_id		('varchar',	32,	true)
-	->blog_id		('varchar',	32,	true)
-	->log_table	('varchar',	255,	false)
-	->log_dt		('timestamp',	0,	false,	'now()')
-	->log_ip		('varchar',	39,	false)
-	->log_msg		('text',	0,	true,	null)
+	->log_id				('bigint',		0,		false)
+	->user_id				('varchar',		32,		true)
+	->blog_id				('varchar',		32,		true)
+	->log_table				('varchar',		255,	false)
+	->log_dt				('timestamp',	0,		false,	'now()')
+	->log_ip				('varchar',		39,		false)
+	->log_msg				('text',		0,		true,	null)
 
 	->primary('pk_log','log_id')
@@ -170,6 +170,6 @@
 
 $_s->version
-	->module	('varchar',	64,	false)
-	->version	('varchar',	32,	false)
+	->module				('varchar',		64,		false)
+	->version				('varchar',		32,		false)
 
 	->primary('pk_version','module')
@@ -177,7 +177,7 @@
 
 $_s->ping
-	->post_id		('bigint',	0,	false)
-	->ping_url	('varchar',	255,	false)
-	->ping_dt		('timestamp',	0,	false,	'now()')
+	->post_id				('bigint',		0,		false)
+	->ping_url				('varchar',		255,	false)
+	->ping_dt				('timestamp',	0,		false,	'now()')
 
 	->primary('pk_ping','post_id','ping_url')
@@ -185,19 +185,19 @@
 
 $_s->comment
-	->comment_id			('bigint',	0,	false)
-	->post_id				('bigint',	0,	false)
-	->comment_dt			('timestamp',	0,	false,	'now()')
-	->comment_tz			('varchar',	128,	false,	"'UTC'")
-	->comment_upddt		('timestamp',	0,	false,	'now()')
-	->comment_author		('varchar',	255,	true,	null)
-	->comment_email		('varchar',	255,	true,	null)
-	->comment_site			('varchar',	255,	true,	null)
-	->comment_content		('text',		0,	true)
-	->comment_words		('text',		0,	true,	null)
-	->comment_ip			('varchar',	39,	true,	null)
-	->comment_status		('smallint',	0,	true,	0)
-	->comment_spam_status	('varchar',	128,	true,	0)
-	->comment_spam_filter	('varchar',	32,	true,	null)
-	->comment_trackback		('smallint',	0,	false,	0)
+	->comment_id			('bigint',		0,		false)
+	->post_id				('bigint',		0,		false)
+	->comment_dt			('timestamp',	0,		false,	'now()')
+	->comment_tz			('varchar',		128,	false,	"'UTC'")
+	->comment_upddt			('timestamp',	0,		false,	'now()')
+	->comment_author		('varchar',		255,	true,	null)
+	->comment_email			('varchar',		255,	true,	null)
+	->comment_site			('varchar',		255,	true,	null)
+	->comment_content		('text',		0,		true)
+	->comment_words			('text',		0,		true,	null)
+	->comment_ip			('varchar',		39,		true,	null)
+	->comment_status		('smallint',	0,		true,	0)
+	->comment_spam_status	('varchar',		128,	true,	0)
+	->comment_spam_filter	('varchar',		32,		true,	null)
+	->comment_trackback		('smallint',	0,		false,	0)
 
 	->primary('pk_comment','comment_id')
@@ -205,7 +205,7 @@
 
 $_s->meta
-	->meta_id		('varchar',	255,	false)
-	->meta_type	('varchar',	64,	false)
-	->post_id		('bigint',	0,	false)
+	->meta_id				('varchar',		255,	false)
+	->meta_type				('varchar',		64,		false)
+	->post_id				('bigint',		0,		false)
 
 	->primary('pk_meta','meta_id','meta_type','post_id')
@@ -213,10 +213,10 @@
 
 $_s->pref
-	->pref_id		('varchar',	255,	false)
-	->user_id			('varchar',	32,	true)
-	->pref_ws		('varchar',	32,	false,	"'system'")
-	->pref_value	('text',		0,	true,	null)
-	->pref_type		('varchar',	8,	false,	"'string'")
-	->pref_label	('text',		0,	true)
+	->pref_id				('varchar',		255,	false)
+	->user_id				('varchar',		32,		true)
+	->pref_ws				('varchar',		32,		false,	"'system'")
+	->pref_value			('text',		0,		true,	null)
+	->pref_type				('varchar',		8,		false,	"'string'")
+	->pref_label			('text',		0,		true)
 
 	->unique('uk_pref','pref_ws','pref_id','user_id')
@@ -228,28 +228,28 @@
 $_s->category->index	('idx_category_cat_lft_blog_id',	'btree',	'blog_id', 'cat_lft');
 $_s->category->index	('idx_category_cat_rgt_blog_id',	'btree',	'blog_id', 'cat_rgt');
-$_s->setting->index		('idx_setting_blog_id',			'btree',	'blog_id');
-$_s->user->index		('idx_user_user_default_blog',	'btree',	'user_default_blog');
-$_s->permissions->index	('idx_permissions_blog_id',		'btree',	'blog_id');
-$_s->post->index		('idx_post_cat_id',				'btree',	'cat_id');
-$_s->post->index		('idx_post_user_id',			'btree',	'user_id');
-$_s->post->index		('idx_post_blog_id',			'btree',	'blog_id');
-$_s->media->index		('idx_media_user_id',			'btree',	'user_id');
-$_s->post_media->index	('idx_post_media_post_id',		'btree',	'post_id');
-$_s->post_media->index	('idx_post_media_media_id',		'btree',	'media_id');
-$_s->log->index		('idx_log_user_id',				'btree',	'user_id');
-$_s->comment->index		('idx_comment_post_id',			'btree',	'post_id');
-$_s->meta->index		('idx_meta_post_id',	'btree','post_id');
-$_s->meta->index		('idx_meta_meta_type',	'btree','meta_type');
-$_s->pref->index		('idx_pref_user_id',			'btree',	'user_id');
+$_s->setting->index		('idx_setting_blog_id',				'btree',	'blog_id');
+$_s->user->index		('idx_user_user_default_blog',		'btree',	'user_default_blog');
+$_s->permissions->index	('idx_permissions_blog_id',			'btree',	'blog_id');
+$_s->post->index		('idx_post_cat_id',					'btree',	'cat_id');
+$_s->post->index		('idx_post_user_id',				'btree',	'user_id');
+$_s->post->index		('idx_post_blog_id',				'btree',	'blog_id');
+$_s->media->index		('idx_media_user_id',				'btree',	'user_id');
+$_s->post_media->index	('idx_post_media_post_id',			'btree',	'post_id');
+$_s->post_media->index	('idx_post_media_media_id',			'btree',	'media_id');
+$_s->log->index			('idx_log_user_id',					'btree',	'user_id');
+$_s->comment->index		('idx_comment_post_id',				'btree',	'post_id');
+$_s->meta->index		('idx_meta_post_id',				'btree',	'post_id');
+$_s->meta->index		('idx_meta_meta_type',				'btree',	'meta_type');
+$_s->pref->index		('idx_pref_user_id',				'btree',	'user_id');
 
 /* Performance indexes
 -------------------------------------------------------- */
 $_s->comment->index		('idx_comment_post_id_dt_status',	'btree',	'post_id', 'comment_dt', 'comment_status');
-$_s->post->index		('idx_post_post_dt',			'btree',	'post_dt');
-$_s->post->index		('idx_post_post_dt_post_id',		'btree',	'post_dt','post_id');
-$_s->post->index		('idx_blog_post_post_dt_post_id',	'btree',	'blog_id','post_dt','post_id');
-$_s->post->index		('idx_blog_post_post_status',		'btree',	'blog_id','post_status');
-$_s->blog->index		('idx_blog_blog_upddt',			'btree',	'blog_upddt');
-$_s->user->index		('idx_user_user_super',			'btree',	'user_super');
+$_s->post->index		('idx_post_post_dt',				'btree',	'post_dt');
+$_s->post->index		('idx_post_post_dt_post_id',		'btree',	'post_dt', 'post_id');
+$_s->post->index		('idx_blog_post_post_dt_post_id',	'btree',	'blog_id', 'post_dt', 'post_id');
+$_s->post->index		('idx_blog_post_post_status',		'btree',	'blog_id', 'post_status');
+$_s->blog->index		('idx_blog_blog_upddt',				'btree',	'blog_upddt');
+$_s->user->index		('idx_user_user_super',				'btree',	'user_super');
 
 /* Foreign keys
Index: inc/dbschema/upgrade.php
===================================================================
--- inc/dbschema/upgrade.php	(revision 3232)
+++ inc/dbschema/upgrade.php	(revision 3237)
@@ -540,4 +540,10 @@
 		}
 
+		if (version_compare($version,'2.10','<='))
+		{
+			@unlink(DC_ROOT.'/'.'admin/js/jsUpload/vendor/jquery.ui.widget.js');
+			@rmdir(DC_ROOT.'/'.'admin/js/jsUpload/vendor');
+		}
+
 		$core->setVersion('core',DC_VERSION);
 		$core->blogDefaults();
Index: inc/prepend.php
===================================================================
--- inc/prepend.php	(revision 3242)
+++ inc/prepend.php	(revision 3255)
@@ -142,5 +142,5 @@
 # Constants
 define('DC_ROOT',path::real(dirname(__FILE__).'/..'));
-define('DC_VERSION','2.9.2');
+define('DC_VERSION','2.10-dev');
 define('DC_DIGESTS',dirname(__FILE__).'/digests');
 define('DC_L10N_ROOT',dirname(__FILE__).'/../locales');
@@ -189,4 +189,17 @@
 if (!defined('DC_ALLOW_MULTI_MODULES')) {
 	define('DC_ALLOW_MULTI_MODULES',false);
+}
+
+if (!defined('DC_CRYPT_ALGO')) {
+	define('DC_CRYPT_ALGO','sha1');	// As in Dotclear 2.9 and previous
+} else {
+	// Check length of cryptographic algorithm result and exit if less than 40 characters long
+	if (strlen(crypt::hmac(DC_MASTER_KEY,DC_VENDOR_NAME,DC_CRYPT_ALGO)) < 40) {
+		if (!defined('DC_CONTEXT_ADMIN')) {
+			exit('Site temporarily unavailable');
+		} else {
+			exit(DC_CRYPT_ALGO.' cryptographic algorithm configured is not strong enough, please change it.');
+		}
+	}
 }
 
Index: inc/public/default-templates/dotty/rss2.xsl
===================================================================
--- inc/public/default-templates/dotty/rss2.xsl	(revision 3246)
+++ inc/public/default-templates/dotty/rss2.xsl	(revision 3246)
@@ -0,0 +1,120 @@
+<?xml version="1.0" encoding="UTF-8"?>
+<xsl:stylesheet version="1.0"
+xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
+xmlns:content="http://purl.org/rss/1.0/modules/content/"
+xmlns="http://www.w3.org/1999/xhtml">
+
+<xsl:output method="html"/>
+
+<xsl:template match="/">
+<html>
+  <head>
+    <title>{{tpl:lang Subscribe to}} <xsl:value-of select="/rss/channel/title"/></title>
+    <style type="text/css">
+    <![CDATA[
+    body {
+      font: 80% Verdana,Arial,sans-serif;
+      margin: 20px 0;
+      padding: 0 0;
+      background: #fff;
+      color: #000;
+    }
+    a { color: #039; }
+    h1, h2 { font-family: Arial,sans-serif; }
+    h1 { font-size: 160%; margin: 0; }
+    h2 { font-size: 140%; font-weight: bold; margin: 0.5em 0 0.2em 0; }
+    h2 a { text-decoration: none; }
+    p { margin: 0 0 0.5em 0; }
+    #page {
+      margin: 0 80px;
+    }
+    #top {
+      background: #036;
+      padding : 1em;
+      color: #fff;
+    }
+    #top a {
+      color: #fff;
+      text-decoration: none;
+    }
+    #what {
+      padding: 1em;
+      background: #eee;
+      border-bottom: 1px solid #000;
+      font-size: 80%;
+    }
+    #what p {
+      margin: 0 0 0.5em 0;
+    }
+    #footer {
+      border-top: 1px solid #000;
+    }
+    #items {
+      background: #fff;
+      color: inherit;
+    }
+    #items div {
+      margin: 0 0 1em 0;
+    }
+    ]]>
+    </style>
+    <script type="text/javascript"><![CDATA[
+    window.onload = function() {
+      document.getElementById('feedurl').value = window.location.href;
+
+      // Ugly but works ;)
+      var c = document.getElementsByTagName('div');
+      var t = '';
+      for (var i=0; c.length-i != 0; i++) {
+        if (c[i].className == 'item-content') {
+          if (c[i].textContent) {
+            t = c[i].textContent;
+          } else if (c[i].innerText) {
+            t = c[i].innerText;
+          } else {
+            t = '';
+          }
+
+          if (t) { c[i].innerHTML = t; }
+        }
+      }
+    };
+    ]]></script>
+  </head>
+  <body>
+    <div id="page">
+      <div id="top">
+        <h1><a href="{/rss/channel/link}"><xsl:value-of select="/rss/channel/title"/></a></h1>
+        <p><xsl:value-of select="/rss/channel/description"/></p>
+      </div>
+      <div id="what">
+      <h3>{{tpl:lang What is an RSS feed?}}</h3>
+      <p>{{tpl:lang RSS feed is a free blog summary. It provides content
+      (either posts or comments) or  summaries of content, together with links
+      to the full versions, and other metadata. The last published items may
+      then be read by your favorite RSS
+      <a href="http://en.wikipedia.org/wiki/Aggregator">aggregator</a>.}}</p>
+      <h3>{{tpl:lang Subscribe}}</h3>
+      <p>{{tpl:lang Simply copy the following URL into your aggregator:}}</p>
+      <p><input type="text" size="60" value="" id="feedurl" /></p>
+      </div>
+      <div id="items">
+        <xsl:apply-templates select="//item"/>
+      </div>
+      <div id="footer">
+        <p><xsl:value-of select="/rss/channel/copyright"/></p>
+      </div>
+    </div>
+  </body>
+</html>
+</xsl:template>
+
+<!-- Item template -->
+<xsl:template match="item">
+  <div>
+    <h2><a href="{link}"><xsl:value-of select="title"/></a></h2>
+    <div class="item-content"><xsl:value-of select="description" /></div>
+  </div>
+</xsl:template>
+
+</xsl:stylesheet>
Index: plugins/antispam/inc/lib.dc.antispam.php
===================================================================
--- plugins/antispam/inc/lib.dc.antispam.php	(revision 3036)
+++ plugins/antispam/inc/lib.dc.antispam.php	(revision 3231)
@@ -143,5 +143,5 @@
 
 		$user_id = trim(@pack('a32',substr($code,0,32)));
-		$pwd = @unpack('H40hex',substr($code,32,40));
+		$pwd = @unpack('H*hex',substr($code,32));
 
 		if ($user_id === false || $pwd === false) {
Index: plugins/themeEditor/_admin.php
===================================================================
--- plugins/themeEditor/_admin.php	(revision 2820)
+++ plugins/themeEditor/_admin.php	(revision 3251)
@@ -38,4 +38,6 @@
 		try {
 			$core->auth->user_prefs->interface->put('colorsyntax',!empty($_POST['colorsyntax']),'boolean');
+			$core->auth->user_prefs->interface->put('colorsyntax_theme',
+				(!empty($_POST['colorsyntax_theme']) ? $_POST['colorsyntax_theme'] : ''));
 		}
 		catch (Exception $e)
@@ -50,9 +52,71 @@
 		$core->auth->user_prefs->addWorkspace('interface');
 
+		$themes_list = dcPage::getCodeMirrorThemes();
+		$themes_combo = array(__('Default') => '');
+		foreach ($themes_list as $theme) {
+			$themes_combo[$theme] = $theme;
+		}
+
 		echo
-		'<p><label for="colorsyntax" class="classic">'.
-		form::checkbox('colorsyntax',1,$core->auth->user_prefs->interface->colorsyntax).'</label>'.
-		__('Syntax highlighting in theme editor').
-		'</p>';
+			'<div class="fieldset two-cols clearfix">'.
+			'<h5>'.__('Syntax highlighting').'</h5>';
+		echo
+			'<div class="col">'.
+			'<p><label for="colorsyntax" class="classic">'.
+			form::checkbox('colorsyntax',1,$core->auth->user_prefs->interface->colorsyntax).'</label>'.
+			__('Syntax highlighting in theme editor').
+			'</p>';
+		if (count($themes_combo) > 1) {
+			echo
+				'<p><label for="colorsyntax_theme" class="classic">'.__('Theme:').'</label> '.
+				form::combo('colorsyntax_theme',$themes_combo,$core->auth->user_prefs->interface->colorsyntax_theme,
+					'','',false,'onchange="selectTheme()"').
+				'</p>';
+		} else {
+			echo form::hidden('colorsyntax_theme','');
+		}
+		echo '</div>';
+		echo '<div class="col">';
+		echo dcPage::jsCodeMirror('',false,array('javascript'));
+		foreach ($themes_list as $theme) {
+			echo dcPage::cssLoad('js/codemirror/theme/'.$theme.'.css');
+		}
+		echo '
+<textarea id="codemirror" name="codemirror">
+function findSequence(goal) {
+  function find(start, history) {
+    if (start == goal)
+      return history;
+    else if (start > goal)
+      return null;
+    else
+      return find(start + 5, "(" + history + " + 5)") ||
+             find(start * 3, "(" + history + " * 3)");
+  }
+  return find(1, "1");
+}</textarea>';
+		echo
+		'<script>
+			var input = document.getElementById("colorsyntax_theme");
+			var theme = input.options[input.selectedIndex].textContent;
+	    	var editor = CodeMirror.fromTextArea(document.getElementById("codemirror"), {
+	    		mode: "javascript",
+	       		tabMode: "indent",
+	       		lineWrapping: "true",
+	       		lineNumbers: "true",
+	   			matchBrackets: "true",
+	   			autoCloseBrackets: "true",
+	   			theme: "'.($core->auth->user_prefs->interface->colorsyntax_theme != '' ? $core->auth->user_prefs->interface->colorsyntax_theme : 'default').'"
+	   		});
+			function selectTheme() {
+				var input = document.getElementById("colorsyntax_theme");
+				var theme = input.options[input.selectedIndex].value;
+				if (theme == "") theme = "default";
+				editor.setOption("theme", theme);
+				editor.refresh();
+			}
+	    </script>';
+		echo '</div>';
+		echo '</div>';
 	}
 }
Index: plugins/themeEditor/_define.php
===================================================================
--- plugins/themeEditor/_define.php	(revision 2890)
+++ plugins/themeEditor/_define.php	(revision 3251)
@@ -16,5 +16,5 @@
 	/* Description*/		"Theme Editor",
 	/* Author */			"Olivier Meunier",
-	/* Version */			'1.2',
+	/* Version */			'1.3',
 	array(
 		'type'		=>		'plugin'
Index: plugins/themeEditor/index.php
===================================================================
--- plugins/themeEditor/index.php	(revision 3021)
+++ plugins/themeEditor/index.php	(revision 3253)
@@ -19,4 +19,5 @@
 $core->auth->user_prefs->addWorkspace('interface');
 $user_ui_colorsyntax = $core->auth->user_prefs->interface->colorsyntax;
+$user_ui_colorsyntax_theme = $core->auth->user_prefs->interface->colorsyntax_theme;
 
 # Loading themes
@@ -69,28 +70,20 @@
 <html>
 <head>
-  <title><?php echo __('Edit theme files'); ?></title>
-  <?php echo dcPage::cssLoad(dcPage::getPF('themeEditor/style.css'));?>
-  <script type="text/javascript">
-  //<![CDATA[
-  <?php echo dcPage::jsVar('dotclear.msg.saving_document',__("Saving document...")); ?>
-  <?php echo dcPage::jsVar('dotclear.msg.document_saved',__("Document saved")); ?>
-  <?php echo dcPage::jsVar('dotclear.msg.error_occurred',__("An error occurred:")); ?>
-  <?php echo dcPage::jsVar('dotclear.msg.confirm_reset_file',__("Are you sure you want to reset this file?")); ?>
-  <?php echo dcPage::jsVar('dotclear.colorsyntax',$user_ui_colorsyntax); ?>
-  //]]>
-  </script>
-  <?php echo dcPage::jsConfirmClose('file-form'); ?>
-  <script type="text/javascript" src="<?php echo dcPage::getPF('themeEditor/script.js'); ?>"></script>
-<?php if ($user_ui_colorsyntax) { ?>
-  <?php echo dcPage::cssLoad(dcPage::getPF('themeEditor/codemirror/codemirror.css'));?>
-  <?php echo dcPage::cssLoad(dcPage::getPF('themeEditor/codemirror.css'));?>
-  <?php echo dcPage::jsLoad(dcPage::getPF('themeEditor/codemirror/codemirror.js'));?>
-  <?php echo dcPage::jsLoad(dcPage::getPF('themeEditor/codemirror/multiplex.js'));?>
-  <?php echo dcPage::jsLoad(dcPage::getPF('themeEditor/codemirror/xml.js'));?>
-  <?php echo dcPage::jsLoad(dcPage::getPF('themeEditor/codemirror/javascript.js'));?>
-  <?php echo dcPage::jsLoad(dcPage::getPF('themeEditor/codemirror/css.js'));?>
-  <?php echo dcPage::jsLoad(dcPage::getPF('themeEditor/codemirror/php.js'));?>
-  <?php echo dcPage::jsLoad(dcPage::getPF('themeEditor/codemirror/htmlmixed.js'));?>
-<?php } ?>
+	<title><?php echo __('Edit theme files'); ?></title>
+	<script type="text/javascript">
+	//<![CDATA[
+		<?php echo dcPage::jsVar('dotclear.msg.saving_document',__("Saving document...")); ?>
+		<?php echo dcPage::jsVar('dotclear.msg.document_saved',__("Document saved")); ?>
+		<?php echo dcPage::jsVar('dotclear.msg.error_occurred',__("An error occurred:")); ?>
+		<?php echo dcPage::jsVar('dotclear.msg.confirm_reset_file',__("Are you sure you want to reset this file?")); ?>
+		<?php echo dcPage::jsVar('dotclear.colorsyntax',$user_ui_colorsyntax); ?>
+	//]]>
+	</script>
+	<?php echo dcPage::jsConfirmClose('file-form'); ?>
+	<script type="text/javascript" src="<?php echo dcPage::getPF('themeEditor/script.js'); ?>"></script>
+	<?php if ($user_ui_colorsyntax) { ?>
+	<?php echo dcPage::jsCodeMirror($user_ui_colorsyntax_theme); ?>
+	<?php } ?>
+	<?php echo dcPage::cssLoad(dcPage::getPF('themeEditor/style.css'));?>
 </head>
 
@@ -171,5 +164,10 @@
 	       		lineWrapping: "true",
 	       		lineNumbers: "true",
-	   			matchBrackets: "true"
+	   			matchBrackets: "true",
+	   			autoCloseBrackets: "true",
+	   			extraKeys: {
+	   				"F11": function(cm) {cm.setOption("fullScreen",!cm.getOption("fullScreen"));}
+	   			}'.
+	   			($user_ui_colorsyntax_theme != '' ? ',theme: "'.$user_ui_colorsyntax_theme.'"' : '').'
 	   		});
 	    </script>';
Index: plugins/widgets/_default_widgets.php
===================================================================
--- plugins/widgets/_default_widgets.php	(revision 2778)
+++ plugins/widgets/_default_widgets.php	(revision 3240)
@@ -20,4 +20,5 @@
 $__widgets->create('search',__('Search engine'),array('defaultWidgets','search'),null,'Search engine form');
 $__widgets->search->setting('title',__('Title (optional)').' :',__('Search'));
+$__widgets->search->setting('placeholder',__('Placeholder (HTML5 only, optional):'),'');
 $__widgets->search->setting('homeonly',__('Display on:'),0,'combo',
 	array(__('All pages') => 0, __('Home page only') => 1, __('Except on home page') => 2));
Index: plugins/widgets/_widgets_functions.php
===================================================================
--- plugins/widgets/_widgets_functions.php	(revision 3030)
+++ plugins/widgets/_widgets_functions.php	(revision 3240)
@@ -36,5 +36,6 @@
 			'<form action="'.$core->blog->url.'" method="get" role="search">'.
 			'<fieldset>'.
-			'<p><input type="text" size="10" maxlength="255" id="q" name="q" value="'.$value.'" /> '.
+			'<p><input type="text" size="10" maxlength="255" id="q" name="q" value="'.$value.'" '.
+			($w->placeholder ? 'placeholder="'.html::escapeHTML($w->placeholder).'"' : '').'/> '.
 			'<input type="submit" class="submit" value="ok" /></p>'.
 			'</fieldset>'.
Index: plugins/widgets/class.widgets.php
===================================================================
--- plugins/widgets/class.widgets.php	(revision 3058)
+++ plugins/widgets/class.widgets.php	(revision 3223)
@@ -320,5 +320,5 @@
 				$res .=
 				'<p><label for="'.$wfid.'">'.$s['title'].'</label> '.
-				form::textarea(array($iname,$wfid),30,5,html::escapeHTML($s['value']),'maximal').
+				form::textarea(array($iname,$wfid),30,8,html::escapeHTML($s['value']),'maximal').
 				'</p>';
 				break;
Index: plugins/widgets/index.php
===================================================================
--- plugins/widgets/index.php	(revision 3021)
+++ plugins/widgets/index.php	(revision 3223)
@@ -234,5 +234,8 @@
   //]]>
   </script>
-  <?php echo $core->callBehavior('adminPostEditor');?>
+  <?php
+  		$widget_editor = $core->auth->getOption('editor');
+  		echo $core->callBehavior('adminPostEditor',$widget_editor['xhtml'],'widget',array('#sidebarsWidgets textarea'),'xhtml');
+  ?>
   <?php echo(dcPage::jsConfirmClose('sidebarsWidgets')); ?>
 </head>
Index: plugins/widgets/widgets.js
===================================================================
--- plugins/widgets/widgets.js	(revision 2563)
+++ plugins/widgets/widgets.js	(revision 3223)
@@ -126,3 +126,12 @@
 		reorder($this.parents('ul.connected'));
 	});
+
+	// HTML text editor
+	if ($.isFunction(jsToolBar)) {
+		$('#sidebarsWidgets textarea').each(function() {
+			var tbWidgetText = new jsToolBar(this);
+			tbWidgetText.draw('xhtml');
+		});
+	}
+
 });
